//+------------------------------------------------------------------+
//|                                              VSA_Volume.mq4      |
//|                                              V.1.0               |
//+------------------------------------------------------------------+
//| ANYONE CAN IMPROVE THIS CODE, IT' S UNDER GPL                    |
//| BUT PLEASE INSERT YOUR REFERENCE AND CHANGELOG                   |
//|                                                                  |
//| IN CASE YOU IMPROVE THE CODE OR FOUND BUGS EMAIL ME              |
//|                                                                  |
//| Defcon                                  defcon1nowhere@gmail.com |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Black
#property indicator_color4 Blue

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 1

//----
extern int   MaxBars=500;
extern int   SMA1period = 3;
extern int   SMA2period = 20;
extern color ColorVolumeDW = Red;
extern color ColorVolumeUP = Green;
extern color ColorSMA1 = Blue;
extern color ColorSMA2 = Magenta;

//---- buffers
double BufferVolumeDW[];
double BufferVolumeUP[];
double BufferSMA1[];
double BufferSMA2[];

//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 2, ColorVolumeDW);
   SetIndexBuffer(0, BufferVolumeDW);
   
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 2, ColorVolumeUP);
   SetIndexBuffer(1, BufferVolumeUP);
   
   SetIndexStyle(2,DRAW_LINE, 0, 2, ColorSMA1);
   SetIndexBuffer(2, BufferSMA1);   
   
   SetIndexStyle(3,DRAW_LINE, 0, 1, ColorSMA2);
   SetIndexBuffer(3, BufferSMA2);  
     
//----
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);    
   SetIndexDrawBegin(3,0); 
//---- indicator buffers mapping
   SetIndexBuffer(0,BufferVolumeDW);
   SetIndexBuffer(1,BufferVolumeUP);
   SetIndexBuffer(2,BufferSMA1);
   SetIndexBuffer(3,BufferSMA2);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haVolume,SMA1,SMA2;
   
   if(Bars<=10) return(0);
   
   ExtCountedBars=IndicatorCounted();

   for(int pos=MaxBars; pos>=0;pos--)
      {
         
         if(Volume[pos]<(Volume[pos+1])) 
            {
            BufferVolumeDW[pos]=Volume[pos];
            BufferVolumeUP[pos]=0;                    
            }
            
         if(Volume[pos]>=(Volume[pos+1])) 
            {
            BufferVolumeDW[pos]=0;
            BufferVolumeUP[pos]=Volume[pos];                    
            }
      //MOVING AVERAGE OF VOLUME 1
      SMA1=0;
      
      for ( int j=pos;j<pos+SMA1period;j++ )
            {
               SMA1= Volume[j] + SMA1; 
            } 
            
      BufferSMA1[pos] = NormalizeDouble(SMA1/SMA1period,4);
         
      //MOVING AVERAGE OF VOLUME 2   
      SMA2=0;      
      for (j=pos;j<pos+SMA2period;j++ )
            {
               SMA2= Volume[j] + SMA2; 
            } 

      BufferSMA2[pos]= NormalizeDouble(SMA2/SMA2period,4);
                                 
      }
 
//----
   return(0);
  }
//+------------------------------------------------------------------+